/*
 *	Copyright (c) 1992 Morning Star Technologies
 *	All rights reserved
 *
 *	Redistribution and use of this software in source and binary
 *	forms are permitted provided that the above copyright notice
 *	and this paragraph are duplicated in all such forms and that
 *	any documentation, advertising materials, and other materials
 *	related to such distribution and use acknowledge that the
 *	software was developed by Morning Star Technologies, Inc.  The
 *	name of Morning Star Technologies, Inc. may not be used to
 *	endorse or promote products derived from this software without
 *	specific prior written permission.  THIS SOFTWARE IS PROVIDED
 *	``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 *	INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 *	MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

# include	<stdio.h>
# include	<sys/types.h>
# include	<sys/signal.h>
# include	<sys/time.h>
# include	<sys/socket.h>
# include	<netinet/in.h>
# include	<arpa/inet.h>
# include	<netdb.h>

main(argc, argv)
int argc;
char **argv;
    {
    extern char *strcpy(), *memcpy();

    register struct hostent *host = 0;
    struct sockaddr_in sin;
    struct servent *sp = 0;
    static char hnamebuf[32];
    unsigned long temp;
    int s;

    if (argc != 2 && argc != 3)
	{
	(void)fprintf(stderr, "Usage: %s hostname [port]\n", argv[0]);
	exit(1);
	}

    temp = inet_addr(argv[1]);

    if (temp != (unsigned long)-1)
	{
	sin.sin_addr.s_addr = temp;
	sin.sin_family = AF_INET;
	(void)strcpy(hnamebuf, argv[1]);
	}
    else
	{
	host = gethostbyname(argv[1]);

	if (host)
	    {
	    sin.sin_family = host -> h_addrtype;

# ifdef h_addr		/* In 4.3, this is a #define */
	    (void)memcpy((caddr_t)&sin.sin_addr, host -> h_addr_list[0],
			 host -> h_length);
# else
	    (void)memcpy((caddr_t)&sin.sin_addr, host -> h_addr,
			 host -> h_length);
# endif
	    }
	else
	    {
	    herror(argv[1]);
	    exit(1);
	    }
	}

    if (argc == 3)
	{
	sin.sin_port = atoi(argv[2]);

	if (sin.sin_port == 0)
	    {
	    sp = getservbyname(argv[2], "tcp");

	    if (sp)
		sin.sin_port = sp -> s_port;
	    else
		{
		(void)fprintf(stderr, "Bad port number (%s)\n", argv[2]);
		exit(1);
		}
	    }
	else
	    sin.sin_port = htons(sin.sin_port);
	}
    else
	sin.sin_port = htons(23);

    (void)printf("Opening %s, port %d...", inet_ntoa(sin.sin_addr),
		 ntohs(sin.sin_port));
    (void)fflush(stdout);

    if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
	(void)printf("\n");
	perror("Can't create socket");
	exit(1);
	}

    if (connect(s, (struct sockaddr *)&sin, sizeof (sin)) < 0)
	{
	(void)printf("\n");
	perror("Unable to connect to remote host");
	exit(1);
	}

    (void)printf("\n");
    (void)fflush(stdout);
    do_session(s);
    exit(0);
    }

# if !defined(__QNX__) && (!defined(BSD) || (BSD <= 43))

char *h_errlist[] =
    {
    "Error 0",
    "Unknown host",				/* 1 HOST_NOT_FOUND */
    "Host name lookup failure",			/* 2 TRY_AGAIN */
    "Unknown server error",			/* 3 NO_RECOVERY */
    "No address associated with name",		/* 4 NO_ADDRESS */
    };

/*
 * herror --
 *      print the error indicated by the h_errno value.
 */
herror(s)
char *s;
    {
    if (s && *s)
	(void)fprintf(stderr, "%s: ", s);

# ifdef RESOLVE
    if ((h_errno < 0) || (h_errno >= sizeof(h_errlist) / sizeof(h_errlist[0])))
	(void)fprintf(stderr, "Unknown error\n");
    else
	if (h_errno == 0)
	    (void)fprintf(stderr, "Host unknown\n");
	else
	    (void)fprintf(stderr, "%s\n", h_errlist[h_errno]);
# else
    (void)fprintf(stderr, "No resolv library -- unknown error\n");
# endif
    }

# endif

# define	IAC	255	/* interpret as command: */
# define	DONT	254	/* you are not to use option */
# define	DO	253	/* please, you use option */
# define	WONT	252	/* I won't use option */
# define	WILL	251	/* I will use option */
# define	SB	250	/* interpret as subnegotiation */
# define	GA	249	/* you may reverse the line */
# define	EL	248	/* erase the current line */
# define	EC	247	/* erase the current character */
# define	AYT	246	/* are you there */
# define	AO	245	/* abort output--but let prog finish */
# define	IP	244	/* interrupt process--permanently */
# define	BREAK	243	/* break */
# define	DM	242	/* data mark--for connect. cleaning */
# define	NOP	241	/* nop */
# define	SE	240	/* end sub negotiation */
# define	EOR	239	/* end of record (transparent mode) */
# define	ABORT	238	/* Abort process */
# define	SUSP	237	/* Suspend process */
# define	xEOF	236	/* End of file: EOF is already used... */

/* telnet options */
# define	TELOPT_BINARY	0 /* 8-bit data path */
# define	TELOPT_ECHO	1 /* echo */
# define	TELOPT_RCP	2 /* prepare to reconnect */
# define	TELOPT_SGA	3 /* suppress go ahead */
# define	TELOPT_NAMS	4 /* approximate message size */
# define	TELOPT_STATUS	5 /* give status */
# define	TELOPT_TM	6 /* timing mark */
# define	TELOPT_RCTE	7 /* remote controlled transmission and echo */
# define	TELOPT_NAOL 	8 /* negotiate about output line width */
# define	TELOPT_NAOP 	9 /* negotiate about output page size */
# define	TELOPT_NAOCRD	10 /* negotiate about CR disposition */
# define	TELOPT_NAOHTS	11 /* negotiate about horizontal tabstops */
# define	TELOPT_NAOHTD	12 /* negotiate about horizontal tab disp'n */
# define	TELOPT_NAOFFD	13 /* negotiate about formfeed disposition */
# define	TELOPT_NAOVTS	14 /* negotiate about vertical tab stops */
# define	TELOPT_NAOVTD	15 /* negotiate about vertical tab disp'n */
# define	TELOPT_NAOLFD	16 /* negotiate about output LF disposition */
# define	TELOPT_XASCII	17 /* extended ascic character set */
# define	TELOPT_LOGOUT	18 /* force logout */
# define	TELOPT_BM	19 /* byte macro */
# define	TELOPT_DET	20 /* data entry terminal */
# define	TELOPT_SUPDUP	21 /* supdup protocol */
# define	TELOPT_SUPDUPOUTPUT 22 /* supdup output */
# define	TELOPT_SNDLOC	23 /* send location */
# define	TELOPT_TTYPE	24 /* terminal type */
# define	TELOPT_EOR	25 /* end or record */
# define	TELOPT_TUID	26 /* TACACS user identification */
# define	TELOPT_OUTMRK	27 /* output marking */
# define	TELOPT_TTYLOC	28 /* terminal location number */
# define	TELOPT_3270REGIME 29 /* 3270 regime */
# define	TELOPT_X3PAD	30 /* X.3 PAD */
# define	TELOPT_NAWS	31 /* window size */
# define	TELOPT_TSPEED	32 /* terminal speed */
# define	TELOPT_LFLOW	33 /* remote flow control */
# define	TELOPT_LINEMODE	34 /* Linemode option */
# define	TELOPT_XDISPLOC	35 /* X Display Location */
# define	TELOPT_ENVIRON	36 /* Environment variables */
# define	TELOPT_AUTHENTICATION 37 /* Authenticate */
# define	TELOPT_ENCRYPT	38 /* Encryption option */
# define	TELOPT_EXOPL	255 /* extended-options-list */

# define	NTELOPTS	(1+TELOPT_ENCRYPT)

char *telopts[NTELOPTS+1] =
    {
    "BINARY", "ECHO", "RCP", "SUPPRESS GO AHEAD", "NAME",
    "STATUS", "TIMING MARK", "RCTE", "NAOL", "NAOP",
    "NAOCRD", "NAOHTS", "NAOHTD", "NAOFFD", "NAOVTS",
    "NAOVTD", "NAOLFD", "EXTEND ASCII", "LOGOUT", "BYTE MACRO",
    "DATA ENTRY TERMINAL", "SUPDUP", "SUPDUP OUTPUT",
    "SEND LOCATION", "TERMINAL TYPE", "END OF RECORD",
    "TACACS UID", "OUTPUT MARKING", "TTYLOC",
    "3270 REGIME", "X.3 PAD", "NAWS", "TSPEED", "LFLOW",
    "LINEMODE", "XDISPLOC", "ENVIRON", "AUTHENTICATION",
    "ENCRYPT",
    0,
    };

telnet_wont(s, opt)
int s, opt;
    {
    unsigned char buf[3];

    buf[0] = IAC; buf[1] = WONT; buf[2] = opt;

    if (opt < NTELOPTS)
	(void)printf(" WONT %s\n", telopts[opt]);
    else
	(void)printf(" WONT option %d\n", opt);

    (void)fflush(stdout);

    if (write(s, (char *)buf, 3) < 0)
	{ perror("Write error on socket"); exit(1); }
    }

telnet_dont(s, opt)
int s, opt;
    {
    unsigned char buf[3];

    buf[0] = IAC; buf[1] = DONT; buf[2] = opt;

    if (opt < NTELOPTS)
	(void)printf(" DONT %s\n", telopts[opt]);
    else
	(void)printf(" DONT option %d\n", opt);

    (void)fflush(stdout);

    if (write(s, (char *)buf, 3) < 0)
	{ perror("Write error on socket"); exit(1); }
    }

telnet_do(s, opt)
int s, opt;
    {
    unsigned char buf[3];

    buf[0] = IAC; buf[1] = DO; buf[2] = opt;

    if (opt < NTELOPTS)
	(void)printf(" DO %s\n", telopts[opt]);
    else
	(void)printf(" DO option %d\n", opt);

    (void)fflush(stdout);

    if (write(s, (char *)buf, 3) < 0)
	{ perror("Write error on socket"); exit(1); }
    }

do_telnet_cmd(s, docmd, opt)
int s, docmd, opt;
    {
    docmd &= 0xFF;
    opt &= 0xFF;

    switch (docmd)
	{
	case DO:   telnet_wont(s, opt); break;
	case DONT: break;
	case WILL: if (opt == TELOPT_ECHO)
			telnet_do(s, opt);
		    else
			telnet_dont(s, opt);
		    break;
	case WONT: break;
	default:   (void)printf("got IAC %d %d\n", docmd, opt);
	}
    }

unsigned char buf[1024], *buf_start = buf, *buf_end = buf;
int state = 0, docmd, min = 0, max = 0, count = 0, sum = 0;

void print_summary()
    {
    if (count)
	{
	int average = sum / count;

	(void)printf("\nmin/average/max = %d.%03d/%d.%03d/%d.%03d\n",
		     min / 1000, min % 1000,
		     average / 1000, average % 1000,
		     max / 1000, max % 1000);
	}

    (void)fflush(stdout);
    exit(0);
    }


int read_char(s)
int s;
    {
    for (;;)
	{
	int n, c;

	while (buf_start == buf_end)
	    {
	    if ((n = read(s, (char *)buf, sizeof buf)) < 0)
		{ perror("Read error on socket"); print_summary(); }

	    buf_start = buf;
	    buf_end = buf_start + n;
	    }

	c = (int)*buf_start & 0xFF;
	++buf_start;

	switch (state)
	    {
	    case 0: if (c == IAC) state = 1; else return (c); break;
	    case 1: docmd = c; state = 2; break;
	    case 2: do_telnet_cmd(s, docmd, c); state = 0;
	    }
	}
    }

do_session(s)
int s;
    {
    int c;

    (void)signal(SIGINT, print_summary);
    (void)signal(SIGPIPE, print_summary);

    do
	{
	(void)putchar(c = read_char(s));
	(void)fflush(stdout);
	} while (c != ':');

    (void)printf("\n");
    (void)fflush(stdout);

    for (;;)
	{
	struct timeval start_tv, end_tv;
	int done = 0, elapsed;

	if (gettimeofday(&start_tv, (struct timezone *)0) < 0)
	    { perror("gettimeofday"); exit(1); }

	if (write(s, "X", 1) < 0)
	    { perror("Write error on socket"); exit(1); }

	while ( ! done)
	    if (read_char(s) == 'X')
		done = 1;

	if (gettimeofday(&end_tv, (struct timezone *)0) < 0)
	    { perror("gettimeofday"); exit(1); }

	elapsed = (end_tv.tv_sec - start_tv.tv_sec) * 1000 +
	    (end_tv.tv_usec - start_tv.tv_usec + 500) / 1000;

	(void)printf("%d.%03d\n", elapsed / 1000, elapsed % 1000);

	if (count == 0)
	    min = max = elapsed;

	if (elapsed < min)
	    min = elapsed;

	if (elapsed > max)
	    max = elapsed;
	    
	sum += elapsed;
	++count;

	(void)fflush(stdout);
	sleep(1);
	}
    }
